//+------------------------------------------------------------------+
//|                                                  TrendlessAG.mq4 |
//|                                      Copyright  2012, Barmaley  |
//|      ,     |
//|     "     |
//|"                                                         |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Barmaley"

#property indicator_separate_window               //  
#property indicator_buffers 1                     //  
//----  

extern int SMAPeriod=7;  //      
extern int PointsCount=600; //    . -    .  -   .
extern int In100=90; //  %       +-100%

//----  
#property  indicator_color1  Yellow                 //   
//----  
double Buf[];  //   
double BufX[]; //  

//+------------------------------------------------------------------+
//| .  init                                      |
//+------------------------------------------------------------------+
int init()
  {
  
  ArrayResize(BufX, PointsCount);

//----  ,     
   SetIndexDrawBegin(0,PointsCount);                
   IndicatorDigits(1);
//----  
   SetIndexBuffer(0,Buf);           //   

//----      
   string short_name="TrendlessAG ("+SMAPeriod+")";       //     SMA
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name); 
   
//----      
   SetLevelValue(1,100.0);                   // 100% 
   SetLevelValue(2,80.0);                    // 80% 
   SetLevelValue(3,60.0);                    // 60% 
   SetLevelValue(4,0.0);                     // 0
   SetLevelValue(5,-60.0);                   // 60% 
   SetLevelValue(6,-80.0);                   // 80% 
   SetLevelValue(7,-100.0);                  // 100% 
//----  
   SetLevelStyle(STYLE_DOT,1,Silver);      //       
//----  
   return(0);
  }
//+------------------------------------------------------------------+
//| TrendlessAG                                                      |
//+------------------------------------------------------------------+
int start()
  {

   int limit=PointsCount; //     ?

   for(int i=0; i<limit; i++) 
   {
   Buf[i]=Close[i]-iMA(Symbol(),Period(),SMAPeriod,0,MODE_SMA,PRICE_CLOSE,i); //  Close-SMA    
   BufX[i]=MathAbs(Buf[i]); //     Close-SMA
   }
   
   ArraySort(BufX); //     
   
   double level_100=BufX[limit*In100/100]; //   +-100%. In100=90%   -   .
   
   for(i=0; i<limit; i++) Buf[i]=Buf[i]/level_100*100; //    100%- .
   
   return(0);
  }
//+------------------------------------------------------------------+

